Subject: [rohc] Question of ROHC

From: [email-masked]
Date: Thu, 18 Mar 2004 10:05:32 +0800

If for this case: 
   +-------------------------------+ 
   |              RTP              | 
   +-------------------------------+ 
   |              UTP              | 
   +-------------------------------+ 
   |              AH               | 
   +-------------------------------+ 
   |           Inner IP            | 
   +-------------------------------+ 
   |              AH               | 
   +-------------------------------+ 
   |           Outer IP            | 
   +-------------------------------+ 
The format of IR packet? 
     0   1   2   3   4   5   6   7 
    --- --- --- --- --- --- --- --- 
   |         Add-CID octet         |  if for small CIDs and CID != 0 
   +---+---+---+---+---+---+---+---+ 
   | 1   1   1   1   1   1   0 | D | 
   +---+---+---+---+---+---+---+---+ 
   |                               | 
   /    0-2 octets of CID info     /  1-2 octets if for large CIDs 
   |                               | 
   +---+---+---+---+---+---+---+---+ 
   |            Profile            |  1 octet 
   +---+---+---+---+---+---+---+---+ 
   |              CRC              |  1 octet 
   +---+---+---+---+---+---+---+---+ 
   |    Outer IP static part???    | 
   |    Inner IP static part???    |static chain 
   |        UDP static part        | 
   |        RTP static part        |variable length 
   +---+---+---+---+---+---+---+---+ 
   |                               | 
   |         Dynamic chain         |  present if D = 1, variable length 
   |                               | 
    - - - - - - - - - - - - - - - - 
   |                               | 
   |           Payload             |  variable length 
   |                               | 
    - - - - - - - - - - - - - - - - 

Generic extension header list 
   +---+---+---+---+---+---+---+---+ 
   | / Generic extension header /  | varial length 
   | /  list of outer IP (AH)   /  |   
   +---+---+---+---+---+---+---+---+ 
   | / Generic extension header /  | varial length 
   | /  list of inner IP (AH)   /  |   
   +---+---+---+---+---+---+---+---+ 
Is it right? 
1. Is there only outer IP static part exists in IR packet? 
2. If yes, does outer IP static part precede inner IP static part or else? 
And does Generic extension header list of outer IP precede Generic 
extension 
header list of inner IP? 
3. If no, how to explain the following 2 sentence in RFC3095? 
   1)  In firs paragraph of Chapter 5.8.5/RFC3095, there is one sentence: 
       When there is more than one IP header, there is more than one list 
of 
       extension headers. 
   2)  In Chapter 5.8/RFC3095, there is another sentence: 
       IPv6 base headers and IPv4 headers cannot be part of an extension 
       header chain. 

Best Regards

Zhou Zongming 周宗明
===========================================================================
COMMIT Incorporated
Add: 18 Shenwang Rd, Xinzhuang Industrial Development Zone, Shanghai China
Post Code: 201108
Tel: +86-21-5442-4885 Ext:3405
FAX: +86-21-5442-4886
Email: [email-masked]
===========================================================================
The information contained in this e-mail and any attachments thereto from 
COMMIT Incorporated is intended to be for the use of the person named 
above and may be private, confidential and privileged. If you are not the 
intended recipient of this transmission, you are hereby notified that any 
disclosure, copying, distribution, printing or use of the contents of this 
communication is strictly prohibited. If you have received this e-mail in 
error, please notify the sender immediately and permanently delete the 
original and any copies of this email and any attachments thereto.

---

From: "Lars-Erik Jonsson (LU/EAB)" <[email-masked]>
Date: Tue, 23 Mar 2004 15:36:11 +0100

I've tried to answer below, let me know if I have misunderstood your questions.
 
/L-E

-----Original Message-----
From: [email-masked] [mailto:[email-masked]]On Behalf Of [email-masked]
Sent: den 18 mars 2004 03:06
To: [email-masked]
Subject: [rohc] Question of ROHC

If for this case: 
[LEJ] Yes, looks ok!
  
Generic extension header list 
  +---+---+---+---+---+---+---+---+ 
  | / Generic extension header /  | varial length 
  | /  list of outer IP (AH)   /  |   
  +---+---+---+---+---+---+---+---+ 
  | / Generic extension header /  | varial length 
  | /  list of inner IP (AH)   /  |   
  +---+---+---+---+---+---+---+---+ 
Is it right? 
1. Is there only outer IP static part exists in IR packet? 
[LEJ] No! The profiles in 3095 can handle one outer and one inner IP header.
These base headers are compressed and fields sent in static/dynamic chains.
For each IP header, there are potentially an extension header list (each IP
header is thus handled separately).
 
2. If yes, does outer IP static part precede inner IP static part or else? 
And does Generic extension header list of outer IP precede Generic extension 
header list of inner IP? 
3. If no, how to explain the following 2 sentence in RFC3095? 
  1)  In firs paragraph of Chapter 5.8.5/RFC3095, there is one sentence: 
      When there is more than one IP header, there is more than one list of 
      extension headers. 
  2)  In Chapter 5.8/RFC3095, there is another sentence: 
      IPv6 base headers and IPv4 headers cannot be part of an extension 
      header chain.
[LEJ] I can not see why these two does not make sense (the first text is
taken from section 5.8.4). One can summarize these two statements with:
"Base headers are compressed, can thus not be part of an extension header
list. For each base header, there is  potentially a list of extension headers.

This communication is confidential and intended solely for the addressee(s). Any unauthorized review, use, disclosure or distribution is prohibited. If you believe this message has been sent to you in error, please notify the sender by replying to this transmission and delete the message without disclosing it. Thank you.

E-mail including attachments is susceptible to data corruption, interruption, unauthorized amendment, tampering and viruses, and we only send and receive e-mails on the basis that we are not liable for any such corruption, interception, amendment, tampering or viruses or any consequences thereof.

---

From: [email-masked]
Date: Wed, 24 Mar 2004 09:43:21 +0800

Hi,L-E

Thanks for your answer! I agree with u!

I think in implementer guide, it should be made clearly that whether Outer IP static part preceeds Inner IP static part or not if inner IP exists

Outer IP/AH/Inner IP/AH/ESP/UDP/RTP

According to extension 3, Inner IP preceeds Outer IP, so I think in IR 
packets maybe the following format( Inner IP preceeds Outer IP) is better:
  +---+---+---+---+---+---+---+---+ 
  |    Inner IP static part???    | 
  |    Outer IP static part???    |static chain 
  |        UDP static part        | 
  |        RTP static part        |variable length 
  +---+---+---+---+---+---+---+---+ 
  |      Inner IP dyn part???     | 
  |      Outer IP dyn part???     |static chain 
  |                               | 
  +---+---+---+---+---+---+---+---+ 

Outer IP static part preceeds Innter IP

   Extension 3:

      0     1     2     3     4     5     6     7
   +-----+-----+-----+-----+-----+-----+-----+-----+
   |  1     1  |  S  |R-TS | Tsc |  I  | ip  | rtp |            (FLAGS)
   +-----+-----+-----+-----+-----+-----+-----+-----+
   |            Inner IP header flags        | ip2 |  if ip = 1
    ..... ..... ..... ..... ..... ..... ..... .....
   |            Outer IP header flags              |  if ip2 = 1
    ..... ..... ..... ..... ..... ..... ..... .....
   |                      SN                       |  if S = 1
    ..... ..... ..... ..... ..... ..... ..... .....
   /       TS (encoded as in section 4.5.6)        /  1-4 octets,
    ..... ..... ..... ..... ..... ..... ..... .....   if R-TS = 1
   |                                               |
   /            Inner IP header fields             /  variable,
   |                                               |  if ip = 1
    ..... ..... ..... ..... ..... ..... ..... .....
   |                     IP-ID                     |  2 octets, if I = 1
    ..... ..... ..... ..... ..... ..... ..... .....
   |                                               |
   /            Outer IP header fields             /  variable,
   |                                               |  if ip2 = 1
    ..... ..... ..... ..... ..... ..... ..... .....
   |                                               |
   /          RTP header flags and fields          /  variable,
   |                                               |  if rtp = 1
    ..... ..... ..... ..... ..... ..... ..... .....

Best Regards
 
Zhou Zongming 周宗明

"Lars-Erik Jonsson (LU/EAB)" <[email-masked]>
2004-03-23 22:36

        To:     "[email-masked]'" <[email-masked]>, [email-masked]
        cc: 
        Subject:        RE: [rohc] Question of ROHC

I've tried to answer below, let me know if I have misunderstood your 
questions.
 
/L-E
-----Original Message-----
From: [email-masked] [mailto:[email-masked]]On Behalf Of [email-masked]
Sent: den 18 mars 2004 03:06
To: [email-masked]
Subject: [rohc] Question of ROHC

If for this case: 
  
Generic extension header list 
  +---+---+---+---+---+---+---+---+ 
  | / Generic extension header /  | varial length 
  | /  list of outer IP (AH)   /  |   
  +---+---+---+---+---+---+---+---+ 
  | / Generic extension header /  | varial length 
  | /  list of inner IP (AH)   /  |   
  +---+---+---+---+---+---+---+---+ 
Is it right? 
1. Is there only outer IP static part exists in IR packet? 
[LEJ] No! The profiles in 3095 can handle one outer and one inner IP 
header.
These base headers are compressed and fields sent in static/dynamic 
chains.
For each IP header, there are potentially an extension header list (each 
IP
header is thus handled separately).
 
list. For each base header, there is  potentially a list of extension 
headers.

This communication is confidential and intended solely for the 
addressee(s). Any unauthorized review, use, disclosure or distribution is 
prohibited. If you believe this message has been sent to you in error, 
please notify the sender by replying to this transmission and delete the 
message without disclosing it. Thank you.

E-mail including attachments is susceptible to data corruption, 
interruption, unauthorized amendment, tampering and viruses, and we only 
send and receive e-mails on the basis that we are not liable for any such 
corruption, interception, amendment, tampering or viruses or any 
consequences thereof.